// 
// `֘Ȁt@C
// 

#include "stdinc.h"
#include "syscall.h"
#include "pg.h"
#include "pce.h"
#include "main.h"
#include "string.h"
#include "sound.h"
#include "hue_image.h"

// external
extern int skip_next_frame;
extern EmuConfig eConf;
extern EmuRuntime eRun;

// global
int skip_next_vsync=0;

// internal
static unsigned int  lasttick=0,framerate = 0;
static int frmcnt=0;

//---------------------------------------------------------------
// PCE.CPutImageŒڌĂ΂B
//---------------------------------------------------------------
void FrameSkipWork(void)
{
//    if(frmcnt==0) {skip_next_frame=1; }
//    frmcnt = (frmcnt+1) % 60;
    
    if( (eConf.skip>>eRun.frame) & 0x01 ) {
        skip_next_frame = 1;
    }

    eRun.frame = (eRun.frame+1) % 4;
}


#ifdef PALWORD //---------------------------------------------------------------

void dbgCDPlay(void);

PALFMT xbuf[WIDTH*HEIGHT+8];


// initialize
void InitImage(void)
{
    ClearImage();

    XBuf = xbuf;
}

// draw image
void PutImage(int x,int y,int w,int h)
{
    register int sx = (SCREEN_WIDTH - w)/2;
    register int sy = (SCREEN_HEIGHT- h)/2;
    register int i,j;

#ifdef GPU
    if(1) {
        /*register*/ DWORD* dst = (DWORD*)pgGetVramAddr(0,0);
        //_memset(xbuf,-1,sizeof(xbuf));
        gpuBitBlt(
            (byte*)xbuf, WIDTH   , 0, 0,
            (byte*)dst , LINESIZE, 0, 0,
            w   , h 
            );
        //sceKernelDcacheWritebackAll();
        sceKernelDcacheWritebackInvalidateAll();
    }
#endif // GPU
    for(j=0;j<h;j++) {    // 16bit palette
        register DWORD* dst = (DWORD*)pgGetVramAddr(sx,sy+j);
        register DWORD* src = (DWORD*)&XBuf[WIDTH*j+x];
        for(i=0;i<w/2;i++) {
            dst[0] = src[0];
            dst++;
            src++;
        }
    }
    
    // t[̏vtick߂
    {
        register DWORD curtick = sceKernelLibcClock();
        framerate = (framerate + (curtick-lasttick))/2;
        lasttick = curtick;
    }
    
    if(eConf.debug) {
        mh_print_dec (0,0,10000000/(framerate+1),RGB_WHITE);
        mh_print_hex4(0,10,x,RGB_WHITE);
        mh_print_hex4(0,20,y,RGB_WHITE);
        mh_print_hex4(0,30,w,RGB_WHITE);
        mh_print_hex4(0,40,h,RGB_WHITE);
#ifdef SOUND
        dbgSound();
#endif // SOUND
#ifdef CDEMULATION
        dbgCDPlay();
#endif//CDEMULATION
    }

//    mh_print_hex8(0,0,io.vce_cr,RGB_WHITE);

    // page flip
    if(eConf.vsync && !skip_next_vsync) pgWaitV();
    //if(framerate<16667)  pgWaitV();

    pgScreenFlip();
}


#else // PALWORD ---------------------------------------------------------------

byte xbuf[WIDTH*HEIGHT+8];
static DWORD d_palette[65536];   // palette table

#define  PALETTE(i) ((((((i)>>2)&7)*36)/8)| (((((i)>>5)*36)/8)<<5) | (((((i)&3)*84)/8)<<10))


// initialize
void InitImage(void)
{
    // create palette buffer
    int i;

    for(i=0;i<sizeof(d_palette)/sizeof(d_palette[0]);i++) {
        d_palette[i] = PALETTE((0x00ff&i)) | (PALETTE((0xff00&i)>>8)<<16);
    }

    // clear image buffer
    ClearImage();

    XBuf = xbuf;
}


//--------------------------------------------------------------------------
// t[`揈
//--------------------------------------------------------------------------
void PutImage(int x,int y,int w,int h)
{
    register int sx = (SCREEN_WIDTH - w)/2;
    register int sy = (SCREEN_HEIGHT- h)/2;
    register int j;
    for(j=0;j<h;j++) {  
        register DWORD* dst = (DWORD*)pgGetVramAddr(sx,sy+j);
        register WORD * src = (WORD*)&XBuf[(WIDTH*j)+x];
        register DWORD* end = dst + w/2;
        for(;dst!=end;){
            *dst++ = d_palette[*src++];
        }
    }
    
    // t[̏vtick߂
    {
        register DWORD curtick = sceKernelLibcClock();
        framerate = (framerate + (curtick-lasttick))/2;
        lasttick = curtick;
    }
    
    if(eConf.debug) {
        mh_print_dec(0,0,1000000/framerate,RGB_WHITE);
        mh_print_hex4(0,10,x,RGB_WHITE);
        mh_print_hex4(0,20,y,RGB_WHITE);
        mh_print_hex4(0,30,w,RGB_WHITE);
        mh_print_hex4(0,40,h,RGB_WHITE);
#ifdef SOUND
        dbgSound();
#endif // SOUND
#ifdef CDEMULATION
        dbgCDPlay();
#endif//CDEMULATION
    }

    // page flip
    if(eConf.vsync) pgWaitV();
    pgScreenFlip();
}

#endif// PALWORD ---------------------------------------------------------------





// image clear
void ClearImage(void)
{
    _memset(xbuf,0,sizeof(xbuf));
}

